ExcelHome技术论坛

 找回密码
 免费注册

QQ登录

只需一步,快速开始

快捷登录

搜索
EH技术汇-专业的职场技能充电站 妙哉!函数段子手趣味讲函数 Excel服务器-会Excel,做管理系统 效率神器,一键搞定繁琐工作
HR薪酬管理数字化实战 Excel 2021函数公式学习大典 Excel数据透视表实战秘技 打造核心竞争力的职场宝典
让更多数据处理,一键完成 数据工作者的案头书 免费直播课集锦 ExcelHome出品 - VBA代码宝免费下载
用ChatGPT与VBA一键搞定Excel WPS表格从入门到精通 Excel VBA经典代码实践指南
查看: 912|回复: 6

[求助] VBA Word编程求助

[复制链接]

TA的精华主题

TA的得分主题

发表于 2021-2-4 11:08 | 显示全部楼层 |阅读模式
如图,我的VBA程序想做到检查RTF文档里是否有三线表跨页显示的情况。目前只是做到了检查每一个文档里页码数和表格数的比对,但是无法定位到具体是哪一页出现了跨页情况,测试文档和我的VBA程序已经上传,求大神帮忙看下,万分感谢!
1.
image.png
2.
image.png

3. 我的代码
  1. Private Declare PtrSafe Function GetWindowLong Lib "user32" Alias "GetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long) As Long
  2. Private Declare PtrSafe Function FindWindow Lib "user32" Alias "FindWindowA" (ByVal lpClassName As String, ByVal lpWindowName As String) As Long
  3. Private Declare PtrSafe Function SetWindowLong Lib "user32" Alias "SetWindowLongA" (ByVal hWnd As Long, ByVal nIndex As Long, ByVal dwNewLong As Long) As Long
  4. Private Const GWL_STYLE = (-16)
  5. Private Const WS_THICKFRAME As Long = &H40000 '(恢复大小)
  6. Private Const WS_MINIMIZEBOX As Long = &H20000 '(最小化)
  7. Private Const WS_MAXIMIZEBOX As Long = &H10000 '(最大化)


  8. Private Sub UserForm_Initialize()
  9.    Dim hWndForm As Long
  10.    Dim IStyle As Long
  11.    hWndForm = FindWindow("ThunderDFrame", Me.Caption)
  12.    IStyle = GetWindowLong(hWndForm, GWL_STYLE)
  13.    IStyle = IStyle Or WS_THICKFRAME '还原
  14.    IStyle = IStyle Or WS_MINIMIZEBOX '最小化
  15.    IStyle = IStyle Or WS_MAXIMIZEBOX '最大化
  16.    SetWindowLong hWndForm, GWL_STYLE, IStyle
  17. End Sub


  18. Private Sub CommandButton1_Click()
  19.     Application.ScreenUpdating = True
  20.     Application.DisplayAlerts = False
  21.     Selection.WholeStory
  22.     Selection.Delete Unit:=wdCharacter, Count:=1

  23.     rtfPath = TextBox1.Value
  24.     FName = Dir(rtfPath & "" & "*.rtf")
  25.     n = 0
  26.     For Each f In CreateObject("scripting.FileSystemObject").GetFolder(rtfPath).Files
  27.         fSuff = Split(f.Name, ".")(1)
  28.         If fSuff = "rtf" Then n = n + 1
  29.     Next
  30.    
  31.     'ThisDocument.Tables(1).Delete
  32. '插入表格
  33.     Set myTable = ThisDocument.Tables.Add(Range:=ThisDocument.Range(Start:=0, End:=0), NumRows:=n + 1, NumColumns:=4)
  34.    
  35.     With ThisDocument.Tables(1)
  36.         .Borders.InsideLineStyle = wdLineStyleSingle
  37.         .Borders.OutsideLineStyle = wdLineStyleSingle
  38.     End With
  39.    
  40.     With ThisDocument.Tables(1)
  41.         .Cell(Row:=1, Column:=1).Range.InsertAfter Text:="RTF"
  42.         .Cell(Row:=1, Column:=2).Range.InsertAfter Text:="表格数"
  43.         .Cell(Row:=1, Column:=3).Range.InsertAfter Text:="页码数"
  44.         .Cell(Row:=1, Column:=4).Range.InsertAfter Text:="标记"
  45.     End With
  46.    
  47. '实例化word对象
  48.     On Error Resume Next
  49.     Set docApp = CreateObject("Word.Application")
  50.    
  51.     i = 3
  52.     If Len(FName) > 0 Then
  53. '        Dim oDoc As Document
  54. '        Set oDoc = Word.ActiveDocument
  55. '        Dim oT As Table
  56.         docApp.Documents.Open (rtfPath & "" & FName)
  57.         With ThisDocument.Tables(1)
  58.             .Cell(Row:=2, Column:=1).Range.InsertAfter Text:=FName
  59.             .Cell(Row:=2, Column:=2).Range.InsertAfter Text:=docApp.ActiveDocument.Tables.Count
  60.             .Cell(Row:=2, Column:=3).Range.InsertAfter Text:=docApp.Selection.Information(wdNumberOfPagesInDocument)
  61.         End With
  62.         If docApp.ActiveDocument.Tables.Count <> docApp.Selection.Information(wdNumberOfPagesInDocument) Then
  63.             With ThisDocument.Tables(1)
  64.                 .Cell(Row:=2, Column:=4).Range.InsertAfter Text:="Y"
  65.             End With
  66.             With ThisDocument.Tables(1)
  67.                 .Cell(Row:=2, Column:=1).Range.Font.ColorIndex = wdRed
  68.                 .Cell(Row:=2, Column:=2).Range.Font.ColorIndex = wdRed
  69.                 .Cell(Row:=2, Column:=3).Range.Font.ColorIndex = wdRed
  70.                 .Cell(Row:=2, Column:=4).Range.Font.ColorIndex = wdRed
  71.             End With
  72.         End If
  73.         pctDone = Format(1 / n, "0.0%")
  74.         With UserForm1
  75.             .Label2.Caption = 0
  76.             .Label2.Caption = pctDone
  77.         End With
  78.         docApp.ActiveDocument.Close False
  79.         Do
  80.         FName = Dir
  81.             If FName <> "" Then
  82.                 docApp.Documents.Open (rtfPath & "" & FName)
  83.                 With ThisDocument.Tables(1)
  84.                     .Cell(Row:=i, Column:=1).Range.InsertAfter Text:=FName
  85.                     .Cell(Row:=i, Column:=2).Range.InsertAfter Text:=docApp.ActiveDocument.Tables.Count
  86.                     .Cell(Row:=i, Column:=3).Range.InsertAfter Text:=docApp.Selection.Information(wdNumberOfPagesInDocument)
  87.                 End With
  88.                 If docApp.ActiveDocument.Tables.Count <> docApp.Selection.Information(wdNumberOfPagesInDocument) Then
  89.                     With ThisDocument.Tables(1)
  90.                         .Cell(Row:=i, Column:=4).Range.InsertAfter Text:="Y"
  91.                     End With
  92.                     With ThisDocument.Tables(1)
  93.                         .Cell(Row:=i, Column:=1).Range.Font.ColorIndex = wdRed
  94.                         .Cell(Row:=i, Column:=2).Range.Font.ColorIndex = wdRed
  95.                         .Cell(Row:=i, Column:=3).Range.Font.ColorIndex = wdRed
  96.                         .Cell(Row:=i, Column:=4).Range.Font.ColorIndex = wdRed
  97.                     End With
  98.                 End If
  99.                 pctDone = Format(i / n, "0.0%")
  100.                 With UserForm1
  101.                     .Label2.Caption = 0
  102.                     .Label2.Caption = pctDone
  103.                 End With
  104.                 i = i + 1
  105.                 docApp.ActiveDocument.Close False
  106.             End If
  107.         Loop Until Len(FName) = 0
  108.     End If
  109.     With UserForm1
  110.         .Label2.Caption = 100
  111.     End With
  112.     Set docApp = Nothing
  113.     Application.DisplayAlerts = True
  114.     MsgBox "Finished!", 64, " "
  115. End Sub

  116. Private Sub CommandButton2_Click()
  117.     Set objshell = CreateObject("wscript.shell")
  118.     Set DosExec = objshell.Exec("cmd.exe /c " & "taskkill /f /t /im WINWORD.exe")
  119.     Set DosExec = Nothing
  120.     Set objshell = Nothing
  121. End Sub
复制代码


test1.zip

45.13 KB, 下载次数: 10

测试文档及我的程序

TA的精华主题

TA的得分主题

 楼主| 发表于 2021-2-4 14:57 | 显示全部楼层
有大佬来帮忙解答下吗,目前就是想做到,分别查每一页是否有三线表装不下,并且跨页到了下一页的情况

TA的精华主题

TA的得分主题

发表于 2021-2-4 23:52 | 显示全部楼层
* 请 楼主 试用下面的宏,跨页的表格会变为红色(跨页的单元格第1字符和最后字符不在一页):
  1. Sub aaaa_Test_Tables_Cross_Page()
  2.     Dim t As Table, c As Cell
  3.     For Each t In ActiveDocument.Tables
  4.         For Each c In t.Range.Cells
  5.             With c.Range
  6.                 If Len(.Text) > 2 Then
  7.                     If .Characters.First.Information(wdActiveEndPageNumber) <> _
  8.                         .Characters.Last.Information(wdActiveEndPageNumber) Then
  9.                         t.Range.Font.ColorIndex = wdRed
  10.                     End If
  11.                 End If
  12.             End With
  13.         Next
  14.     Next
  15. End Sub
复制代码

TA的精华主题

TA的得分主题

 楼主| 发表于 2021-2-5 09:08 | 显示全部楼层
本帖最后由 lingongzhe 于 2021-2-5 12:12 编辑
413191246se 发表于 2021-2-4 23:52
* 请 楼主 试用下面的宏,跨页的表格会变为红色(跨页的单元格第1字符和最后字符不在一页):

感谢回复,我把您的这段程序插到了我程序里红色的部分,但是跑完之后没有变化。我调试了下,层主的意思应该是取表格中第一个字符和最后一个字符,但是代码做到的是取了表格中每一个字符的第一个字符和最后一个字符,所以失败了,如何能够取到表格中的第一个和最后一个字符呢?

Private Sub CommandButton1_Click()
    Application.ScreenUpdating = True
    Application.DisplayAlerts = False
    Dim Pstart As Integer, PEnd As Integer, myRange As Range
    Dim t As Table, c As Cell
    Selection.WholeStory
    Selection.Delete unit:=wdCharacter, Count:=1
    rtfPath = TextBox1.Value
    FName = Dir(rtfPath & "\" & "*.rtf")
    n = 0
    For Each f In CreateObject("scripting.FileSystemObject").GetFolder(rtfPath).Files
        If f.Name Like "*.rtf" Then n = n + 1
    Next
   
    'ThisDocument.Tables(1).Delete
'插入表格
    Set myTable = ThisDocument.Tables.Add(Range:=ThisDocument.Range(Start:=0, End:=0), NumRows:=n + 1, NumColumns:=4)
   
    With ThisDocument.Tables(1)
        .Borders.InsideLineStyle = wdLineStyleSingle
        .Borders.OutsideLineStyle = wdLineStyleSingle
    End With
   
    With ThisDocument.Tables(1)
        .Cell(Row:=1, Column:=1).Range.InsertAfter Text:="RTF"
        .Cell(Row:=1, Column:=2).Range.InsertAfter Text:="表格数"
        .Cell(Row:=1, Column:=3).Range.InsertAfter Text:="页码数"
        .Cell(Row:=1, Column:=4).Range.InsertAfter Text:="标记"
    End With
   
'实例化word对象
    On Error Resume Next
    Set docApp = CreateObject("Word.Application")
   
    i = 3
    If Len(FName) > 0 Then
'        Dim oDoc As Document
'        Set oDoc = Word.ActiveDocument
'        Dim oT As Table
        docApp.Documents.Open (rtfPath & "\" & FName)
        tabCount = docApp.ActiveDocument.Tables.Count
        pageCount = docApp.Selection.Information(wdNumberOfPagesInDocument)


        With ThisDocument.Tables(1)
            .Cell(Row:=2, Column:=1).Range.InsertAfter Text:=FName
            .Cell(Row:=2, Column:=2).Range.InsertAfter Text:=tabCount
            .Cell(Row:=2, Column:=3).Range.InsertAfter Text:=pageCount
        End With
        If tabCount <> pageCount Then
            With ThisDocument.Tables(1)
                .Cell(Row:=2, Column:=4).Range.InsertAfter Text:="Y-"
            End With
            With ThisDocument.Tables(1)
                .Cell(Row:=2, Column:=1).Range.Font.ColorIndex = wdRed
                .Cell(Row:=2, Column:=2).Range.Font.ColorIndex = wdRed
                .Cell(Row:=2, Column:=3).Range.Font.ColorIndex = wdRed
                .Cell(Row:=2, Column:=4).Range.Font.ColorIndex = wdRed
            End With
        End If
        '检查跨页
        For Each t In ActiveDocument.Tables
            For Each c In t.Range.Cells
                With c.Range
                    If Len(.Text) > 2 Then
                        If .Characters.First.Information(wdActiveEndPageNumber) <> _
                            .Characters.Last.Information(wdActiveEndPageNumber) Then
                            t.Range.Font.ColorIndex = wdRed
                            MsgBox .Characters.First.Information(wdActiveEndPageNumber)
                            ThisDocument.Tables(1).Cell(Row:=2, Column:=4).Range.InsertAfter Text:=.Characters.First.Information(wdActiveEndPageNumber) & ", "
                        End If
                    End If
                End With
            Next
        Next
        pctDone = Format(1 / n, "0.0%")
        With UserForm1
            .Label2.Caption = 0
            .Label2.Caption = pctDone
        End With
        docApp.ActiveDocument.Close True
        Do
        FName = Dir
            If FName <> "" Then
                docApp.Documents.Open (rtfPath & "\" & FName)
                tabCount = docApp.ActiveDocument.Tables.Count
                pageCount = docApp.Selection.Information(wdNumberOfPagesInDocument)
                With ThisDocument.Tables(1)
                    .Cell(Row:=i, Column:=1).Range.InsertAfter Text:=FName
                    .Cell(Row:=i, Column:=2).Range.InsertAfter Text:=tabCount
                    .Cell(Row:=i, Column:=3).Range.InsertAfter Text:=pageCount
                End With
                If tabCount <> pageCount Then
                    With ThisDocument.Tables(1)
                        .Cell(Row:=i, Column:=4).Range.InsertAfter Text:="Y-"
                    End With
                    With ThisDocument.Tables(1)
                        .Cell(Row:=i, Column:=1).Range.Font.ColorIndex = wdRed
                        .Cell(Row:=i, Column:=2).Range.Font.ColorIndex = wdRed
                        .Cell(Row:=i, Column:=3).Range.Font.ColorIndex = wdRed
                        .Cell(Row:=i, Column:=4).Range.Font.ColorIndex = wdRed
                    End With
                End If
                '检查跨页
                For Each t In ActiveDocument.Tables
                    For Each c In t.Range.Cells
                        With c.Range
                            If Len(.Text) > 2 Then
                                If .Characters.First.Information(wdActiveEndPageNumber) <> _
                                    .Characters.Last.Information(wdActiveEndPageNumber) Then
                                    t.Range.Font.ColorIndex = wdRed
                                    MsgBox .Characters.First.Information(wdActiveEndPageNumber)
                                    ThisDocument.Tables(1).Cell(Row:=2, Column:=4).Range.InsertAfter Text:=.Characters.First.Information(wdActiveEndPageNumber) & ", "
                                End If
                            End If
                        End With
                    Next
                Next
                pctDone = Format(i / n, "0.0%")
                With UserForm1
                    .Label2.Caption = 0
                    .Label2.Caption = pctDone
                End With
                i = i + 1
                docApp.ActiveDocument.Close True
            End If
        Loop Until Len(FName) = 0
    End If
    With UserForm1
        .Label2.Caption = 100
    End With
    Set docApp = Nothing
    Application.DisplayAlerts = True
    MsgBox "Finished!", 64, " "
End Sub




TA的精华主题

TA的得分主题

 楼主| 发表于 2021-2-5 09:09 | 显示全部楼层
[广告] Excel易用宝 - 提升Excel的操作效率 · Excel / WPS表格插件       ★免费下载 ★       ★ 使用帮助
@413191246se , 大佬帮我看看,我这个代码为啥放到循环里就实现不了呀,太奇怪了趴!
  1.                 For currentPage = 1 To pageCount
  2.                     Pstart = Selection.GoTo(what:=wdGoToPage, Which:=wdGoToNext, Name:=1).Start
  3.                     PEnd = Selection.GoTo(what:=wdGoToPage, Which:=wdGoToNext, Name:=currentPage).End
  4.                     Set myRange = ActiveDocument.Range(Pstart, PEnd)
  5.                     nowTabcount = myRange.Tables.Count
  6.                     MsgBox "当前页数:" & currentPage
  7.                     MsgBox "截至当前页的表格数:" & nowTabcount
  8.                 Next
复制代码

TA的精华主题

TA的得分主题

 楼主| 发表于 2021-2-5 19:43 | 显示全部楼层
413191246se 发表于 2021-2-4 23:52
* 请 楼主 试用下面的宏,跨页的表格会变为红色(跨页的单元格第1字符和最后字符不在一页):

哈哈谢谢大佬,虽然你的宏没跑出来,但是已经用的思路解决了这个问题,万分感谢万分感谢!!!!
您需要登录后才可以回帖 登录 | 免费注册

本版积分规则

手机版|关于我们|联系我们|ExcelHome

GMT+8, 2024-11-24 04:41 , Processed in 0.039670 second(s), 10 queries , Gzip On, MemCache On.

Powered by Discuz! X3.4

© 1999-2023 Wooffice Inc.

沪公网安备 31011702000001号 沪ICP备11019229号-2

本论坛言论纯属发表者个人意见,任何违反国家相关法律的言论,本站将协助国家相关部门追究发言者责任!     本站特聘法律顾问:李志群律师

快速回复 返回顶部 返回列表